#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <fcntl.h>
#include <unistd.h>

#include <errno.h>

#include <stdio.h>

#include "ujoy.h"

int
main(int argc, char *argv[])
{
  struct ujoy	joy;
  int	fd;
  int	tmp;
  int i;

  if (argc != 2)
    {
      printf("Usage: %s device\n", argv[0]);
      return 0;
    }
  fd = open(argv[1], O_RDONLY);
  if (fd == -1)
    {
      printf("Can't open %s : %d\n", argv[1], errno);
      return -1;
    }

  if (ioctl(fd, UJOY_GETNUMAXIS, &tmp) != -1)
    printf("Number of axis: %d\n", tmp);
  if (ioctl(fd, UJOY_GETNUMBUTTONS, &tmp) != -1)
    printf("Number of buttons: %d\n", tmp);

  while (1)
    {
      read(fd, &joy, sizeof(struct ujoy));
      if (joy.axis[UJOY_AXIS_X].present)
	printf("X-axis : %d\n", joy.axis[UJOY_AXIS_X].value);
      if (joy.axis[UJOY_AXIS_Y].present)
	printf("Y-axis : %d\n", joy.axis[UJOY_AXIS_Y].value);
      if (joy.axis[UJOY_AXIS_Z].present)
	printf("Z-axis : %d\n", joy.axis[UJOY_AXIS_Z].value);
      if (joy.axis[UJOY_AXIS_RX].present)
	printf("RX-axis : %d\n", joy.axis[UJOY_AXIS_RX].value);
      if (joy.axis[UJOY_AXIS_RY].present)
	printf("RY-axis : %d\n", joy.axis[UJOY_AXIS_RY].value);
      if (joy.axis[UJOY_AXIS_RZ].present)
	printf("RZ-axis : %d\n", joy.axis[UJOY_AXIS_RZ].value);
      if (joy.axis[UJOY_SLIDER].present)
	printf("Slider : %d\n", joy.axis[UJOY_SLIDER].value);
      printf("Hat : %d\n", joy.hat);
      printf("Button : %x\n",  joy.buttons);
    }
}
